# -*- coding: utf-8 -*-
"""
Created on Tue Feb 27 13:11:34 2024

@author: aleja
"""
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt

variables = np.load('fich_datos_PCA.npz')

p=variables['p']
sa=variables['sa']
Qumbral=variables['Qumbral']
Tumbral=variables['Tumbral']
valor_medio=variables['valor_medio']
desviacion_estandar=variables['desviacion_estandar']


datos = pd.read_csv('d21_te.csv')

shape = datos.shape
n=len(datos.axes[0])
m=len(datos.axes[1])


#2 normalizar a media conocida y varianza 1
variable_centralizada = datos - valor_medio

X = variable_centralizada / desviacion_estandar
Xn=X.to_numpy()


T2=[]
for i in range (n):
    
    multi=np.dot(np.dot(np.dot(np.dot(Xn[i,:], p), np.linalg.inv(sa)), np.transpose(p)), np.transpose(Xn[i,:]))

    T2=np.append(T2,multi)
    
  
 #calcular la estadistica Q

Q=[]

for i in range(n):
    R=Xn[i,:]-np.dot(np.dot(Xn[i,:],p),np.transpose(p))
    Rt=np.transpose(R) #para que de la forma adecuada
    Qi=np.dot(Rt,R)
    Q=np.append(Q,Qi)
    
    
ejex=np.arange(n)

plt.title('Estadistico T^2 de Hotelling')
plt.xlabel('t')
plt.ylabel('T^2')
plt.scatter(ejex, T2, c ="green")
plt.axhline(y=Tumbral, color="r", label="Percentil 99")
plt.show()


plt.title('Estadistico Q')
plt.xlabel('t')
plt.ylabel('Q')
plt.scatter(ejex, Q, c ="blue")
plt.axhline(y=Qumbral, color="r", label="Percentil 99")
plt.show()  


#detectar fallos
t_falloT=0
con=0
k=10
fallo=0
for i in range (0,n):
    if T2[i]>Tumbral:
        con=con+1
    else:
        con=0
        
    if con==k:
        fallo =1
        t_falloT=i-9
        break
    
    
print('tiempo para T2',t_falloT)  

  
con=0    
t_falloQ=0
for i in range (0,n):
    if Q[i]>Qumbral:
         con=con+1
    else:
         con=0
        
    if con==k:
        fallo =1
        t_falloQ=i-9
        break
    
#print('tiempo para Q',t_falloQ)
#falsas alarmas
cont=0
for i in range(159):
    if T2[i]>Tumbral:
        cont=cont+1

falsa_alarmaT=cont/160*100

print('falsas alarmas para T2',falsa_alarmaT)

cont2=0
for i in range(159):
    if Q[i]>Qumbral:
        cont2=cont2+1

falsa_alarmaQ=cont2/160*100

#print('falsas alarmas para Q',falsa_alarmaQ)

#alarmas detectadas
con=0
for i in range (160,n):
    if T2[i]>Tumbral:
        con=con+1

alarma_detectadaT=con/800*100
print(' alarmas detectadas para T2',alarma_detectadaT)

con2=0
for i in range (160,n):
    if Q[i]>Qumbral:
        con2=con2+1

alarma_detectadaQ=con2/800*100
#print(' alarmas detectadas para Q',alarma_detectadaQ)


print('tiempo para Q',t_falloQ)
print('falsas alarmas para Q',falsa_alarmaQ)
print(' alarmas detectadas para Q',alarma_detectadaQ)
#################### identificacion fallo
'''
#R_fallo=Xn[t_falloQ,:]# fallo antiguo mal
R_fallo=Xn[t_falloQ,:]-np.dot(np.dot(Xn[t_falloQ,:],p),np.transpose(p))

R_fallo2=np.square(R_fallo)
plt.bar(range(len(R_fallo2)), R_fallo2)
plt.title('Diagrama de barras de fallos PCA d07')
plt.show()
'''

# Simulación de datos (cambia esto por tus valores reales)
R_fallo=Xn[t_falloQ,:]-np.dot(np.dot(Xn[t_falloQ,:],p),np.transpose(p))
R_fallo2 = np.square(R_fallo)  # Elevar al cuadrado cada valor

# Encontrar el valor máximo y su índice
max_valor = np.max(R_fallo2)
max_indice = np.argmax(R_fallo2)
print(f'La variable más alta es {max_valor} en la posición {max_indice}')

# Graficar el diagrama de barras
plt.bar(range(len(R_fallo2)), R_fallo2)
plt.title('Diagrama de barras de fallos PCA d07')
plt.show()



